`timescale 1ns / 1ps
module tb;
integer i, j, k, err_no;
wire [7:0] result;
ALU uut(
    .operand0(j[7:0]),
    .operand1(i[7:0]),
    .operator(k[1:0]),
    .result(result)
);
initial begin
    err_no = 0;
    $display("Testing ADD:");
    k = 0;
    for (i = 0; i < 16; i = i + 1) begin
        for (j = 0; j < 100-i; j = j + 1) begin
            #10;
            if (j + i !== result) begin
                err_no = err_no + 1;
                $display("operand1: %4d ADD operand0: %4d is not %d", j, i, result);
            end
            else begin
                $display("%4d ADD %4d is correct", j, i);
            end
        end
    end
    $display();
    $display("Testing SUB:");
    k = 1;
    for (i = 0; i < 16; i = i + 1) begin
        for (j = i; j < 100; j = j + 1) begin
            #10;
            if (j - i !== result) begin
                err_no = err_no + 1;
                $display("operand1: %4d SUB operand0: %4d is not %d", j, i, result);
            end
            else begin
                $display("%4d SUB %4d is correct", j, i);
            end
        end
    end
    $display();
    $display("Testing SHR:");
    k = 2;
    for (i = 0; i < 16; i = i + 1) begin
        for (j = 0; j < 100; j = j + 1) begin
            #10;
            if (j >> i !== result) begin
                err_no = err_no + 1;
                $display("operand1: %4d >> operand0: %4d is not %d", j, i, result);
            end
            else begin
                $display("%4d >> %4d is correct", j, i);
            end
        end
    end
    $display();
    $display("Testing SHL:");
    k = 3;
    for (i = 0; i < 16; i = i + 1) begin
        for (j = 0; (j << i) < 100; j = j + 1) begin
            #10;
            if ((j << i) !== result) begin
                err_no = err_no + 1;
                $display("operand1: %4d << operand0: %4d is not %d", j, i, result);
            end
            else begin
                $display("%4d << %4d is correct", j, i);
            end
        end
    end
    if (err_no === 0) begin
        $display("\n");
        $display("\n");
        $display("        ****************************    _._     _,-'\"\"`-._        ");
        $display("        **  Congratulations !!    **   (,-.`._,'(       |\\`-/|     ");
        $display("        ** Implementation1 PASS!! **       `-.-' \\ )-`( , o o)     ");
        $display("        ****************************             `-    \\`_`\"'-    ");
        $display("\n");
    end
    else begin
        $display("\n");
        $display("\n");
        $display("        ****************************         |\\      _,,,---,,_     ");
        $display("        **  OOPS!!                **   ZZZzz /,`.-'`'    -.  ;-;;,_  ");
        $display("        **Implementation1 Failed!!**        |,4-  ) )-,_. ,\\ (  `'-'");
        $display("        ****************************       '---''(_/--'  `-'\\_)     ");
        $display("         Totally has %d errors                                       ", err_no); 
        $display("\n");
    end
    $finish;
end
endmodule
