module seg7 (
    input      [3:0] num_i,
    output reg [6:0] seg7_o  // {g, f, e, d, c, b, a}
);

    always @(*) begin
        case (num_i)
            // implement 7 seg decode circuit here
            4'h0: seg7_o = 7'b1000000;
            4'h1: seg7_o = 7'b1111001;
            4'h2: seg7_o = 7'b0100100;
            4'h3: seg7_o = 7'b0110000;
            4'h4: seg7_o = 7'b0011001;
            4'h5: seg7_o = 7'b0010010;
            4'h6: seg7_o = 7'b0000010;
            4'h7: seg7_o = 7'b1111000;
            4'h8: seg7_o = 7'b0000000;
            4'h9: seg7_o = 7'b0010000;
            4'ha: seg7_o = 7'b0001000;
            4'hb: seg7_o = 7'b0000011;
            4'hc: seg7_o = 7'b1000110;
            4'hd: seg7_o = 7'b0100001;
            4'he: seg7_o = 7'b0000110;
            4'hf: seg7_o = 7'b0001110;
            default: seg7_o = 7'b1111111;
        endcase
    end

endmodule